function omcompilerun(filename,modelname,modelica)
%-----------------------------------------------------------------------------------------
%Funktion zum Laden, Kompilieren und Ausfhren eines Modelica Modells (Modelicafile.mo).
%Beim Kompilieren werden die zur eigentlichen Simulatoin bentigten Dateien MODELLNAME.EXE,
%die Datei mit den Parameter- und Startwerten MODELLNAME_INIT.TXT und andere erzeugt.
%Falls diese bereits existieren, werden sie durch aufruf dieser Funktion berschrieben.
%Bei Bedarf knnen die Modelica-Standard-Bibliotheken geladen werden. 
%
%Zur Ermglichung von Parametervariationen werd der nach dem Kompilieren vorliegende 
%Originalzustand in der Datei MODELLNAME_INIT_ORIGINAL.TXT gespeichert.
%
%ACHTUNG: ALLE ALTEN FILES AUSSER DAS MODELL SELBST WERDEN BEIM AUFRUF DER FUNKTION 
%         GELSCHT.
%
%SYNTAX:    omcompilerun(filename,modelname,modelica)
%
%mit:       filename  = NAME DES mo-FILES (String): z.B. 'Testrig.mo'
%           modelname = NAME DES MODELLS (String) bzw. NAME DES PACKAGES.NAME DES MODELLS 
%                       falls das Modell innerhalb eines Packagees liegt:
%                       z.B. 'package.modelname'
%           modelica  = 0 (Modelica Libraries nicht laden) / 1 (Modelica Libraries laden)
%
%(c) Schaad,  Februar 2008
%(m) Hamadeh, April  2008
%-----------------------------------------------------------------------------------------

%% Lschen des MOS-Files, der Executable und Resultdateien, etc.
if exist(modelname,'file')
    delete simo.mos;
    delete([modelname,'.exe']);
    delete([modelname,'_res.plt']);
    delete([modelname,'.makefile']);
    delete([modelname,'.log']);
    delete([modelname,'.libs']);
    delete([modelname,'_init.txt']);
    delete([modelname,'_functions.cpp']);
    delete([modelname,'.cpp']);
end
%% Erzeugen des MOS-Files fr die Kommandozeile des Modelica Compilers
mosstring = ['loadFile("',filename,'");\n instantiateModel(',modelname,');\n  simulate(',modelname,');\n'];
if exist('modelica','var') && modelica == 1
    mosstring = ['loadModel(Modelica);\n loadFile("',filename,'");\n instantiateModel(',modelname,');\n simulate(',modelname,');\n'];
end
fid = fopen('simo.mos','w');
fprintf(fid,mosstring);
fclose(fid);
%% Kompilieren und Simulieren der Kommandos im Modelica-Script-File "simo.mos"
linux = isunix;
% Kopieren der Konfiguratonsdatei nach *originial
switch linux
    case 1
        !omc +s simo.mos
        eval(['!cp ',modelname,'_init.txt ',modelname,'_init_original.txt']);
    case 0
        % Aufruf der omc.exe mit Simulation des Modells und Aufruf der simos.mos
        !C:\Programme\OpenModelica1.4.4\bin\omc.exe +s simo.mos 
        eval(['!copy ',modelname,'_init.txt ',modelname,'_init_original.txt']);
end
